#include "stdafx.h"
#include "FluidSim.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26426)
CFluidSimApp theApp;

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CFluidSimApp, CWinApp)
  ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
END_MESSAGE_MAP()


CFluidSimApp::CFluidSimApp() noexcept : m_nCellCount(64),
                                        m_nCellSize(10),
                                        m_fForce(50.0f),
                                        m_fSource(10.0f),
                                        m_fDiffusion(0.00001f),
                                        m_fDt(0.1f),
                                        m_fViscosity(0),
                                        m_bVelocityField(FALSE)
{
}

BOOL CFluidSimApp::InitInstance()
{
  //Read in the config values
  SetRegistryKey(_T("PJ Naughter"));
  m_nCellCount = GetProfileInt(_T("General"), _T("CellCount"), m_nCellCount);
  m_nCellSize = GetProfileInt(_T("General"), _T("CellSize"), m_nCellSize);
  m_fForce = static_cast<float>(_ttof(GetProfileString(_T("General"), _T("Force"), _T("50.0"))));
  m_fSource = static_cast<float>(_ttof(GetProfileString(_T("General"), _T("Source"), _T("10.0"))));
  m_fDiffusion = static_cast<float>(_ttof(GetProfileString(_T("General"), _T("Diffusion"), _T("0.0001"))));
  m_fDt = static_cast<float>(_ttof(GetProfileString(_T("General"), _T("DT"), _T("0.1"))));
  m_fViscosity = static_cast<float>(_ttof(GetProfileString(_T("General"), _T("Viscosity"), _T("0.0"))));
  m_bVelocityField = GetProfileInt(_T("General"), _T("VelocityField"), m_bVelocityField);

  //Bring up the mainframe window
#pragma warning(suppress: 26400 26409)
  CMainFrame* pFrameWnd = new CMainFrame();
  VERIFY(pFrameWnd->LoadFrame(IDR_MAINFRAME));
  m_pMainWnd = pFrameWnd;
  m_pMainWnd->ShowWindow(SW_SHOW);
  m_pMainWnd->UpdateWindow();

  return TRUE;
}
