#pragma once

#include "FluidSimulator.h"


class CPropertiesDlg : public CDialog
{
public:
//Constructors / Destructors
  CPropertiesDlg(_In_opt_ CWnd* pParent = nullptr);

//Member variables
  enum { IDD = IDD_PROPERTIES };
  int m_nCellCount;
  int m_nCellSize;
  float m_fForce;
  float m_fSource;
  float m_fDiffusion;
  float m_fDt;
  float m_fViscosity;
  BOOL m_bVelocityField;

protected:
//Methods
  void DoDataExchange(CDataExchange* pDX) override;

  DECLARE_MESSAGE_MAP()
};


class CMainFrame : public CFrameWnd
{
public:
//Constructors / Destructors
  CMainFrame();
  CMainFrame(const CMainFrame&) = delete;
  CMainFrame(CMainFrame&&) = delete;
  ~CMainFrame() = default;

//Methods
  CMainFrame& operator=(const CMainFrame&) = delete;
  CMainFrame& operator=(CMainFrame&&) = delete;

protected:
//Member variables
  UINT_PTR m_nTimerID;
  DWORD m_nFramesRenderedInLastSecond;
  ULONGLONG m_nLastSecond;
  DWORD m_nFPS;
  bool m_bCaptured;
  bool m_bLButtownDown;
  bool m_bRButtownDown;
  int m_omx;
  int m_omy;
  int m_mx;
  int m_my;
  CFluidSimulator m_Simulator;

//Methods
  void GetFromUI();

//Message handlers
  afx_msg LRESULT OnDraw2D(WPARAM wParam, LPARAM lParam);
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnDestroy();
  afx_msg void OnViewSimulationProperties();
  afx_msg void OnTimer(UINT_PTR nIDEvent);
  afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnRButtonUp(UINT nFlags, CPoint point) noexcept;
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg void OnLButtonUp(UINT nFlags, CPoint point) noexcept;
  afx_msg void OnViewClear();
  afx_msg void OnMouseMove(UINT nFlags, CPoint point) noexcept;

  DECLARE_MESSAGE_MAP()

  DECLARE_DYNCREATE(CMainFrame)
};
